mod imp;

use glib::Object;
use gtk::{gio, glib::{self, subclass::types::ObjectSubclassIsExt}, Picture};

glib::wrapper! {
    pub struct CardEntry(ObjectSubclass<imp::CardEntry>)
        @extends gtk::Widget,
        @implements gio::ActionGroup, gio::ActionMap, gtk::Accessible, gtk::Buildable,
                    gtk::ConstraintTarget, gtk::Native, gtk::Root, gtk::ShortcutManager;
}

impl CardEntry {
    pub fn new(image_path: &String, hieroglyph: &String, reading: &String) -> Self {
        Object::builder()
            .property("imagepath", image_path)
            .property("hieroglyph", hieroglyph)
            .property("reading", reading)
            .build()
    }

    pub fn get_picture_widget(&self) -> &Picture {
        self.imp().picture.as_ref()
    }
}
